// FrameMaker class for CSCI lab

// (c) J. Dean Brock, 2004, 2006, 2007
// Department of Computer Science
// UNC Asheville

package edu.unca.cs.labaids ;

/**
 * The class contains a single static method that can be used
 * to create and run a JFrame from a JComponent.  It follows the
 * suggestions for thread creation found on Sun's web site.
 */
public class FrameMaker {

    /**
     * Creates and runs and JFrame containing a single JPanel
     * @param title Title of the JFrame
     * @return Newly created JFrame
     * @param canvas JComponent to be framed
     */
    public static javax.swing.JFrame component2Frame(javax.swing.JComponent canvas,
                                                     String title) {
        getFrame sillyVar = new getFrame(canvas, title) ;
        try {
            javax.swing.SwingUtilities.invokeAndWait(sillyVar) ;
        } catch (Exception e) {
            e.printStackTrace() ;
        }
        return sillyVar.safeFrame ;
    }
    
    static class getFrame implements Runnable {
        public  javax.swing.JFrame safeFrame ;
        private javax.swing.JComponent myCanvas ;
        private String myTitle ;
        getFrame(javax.swing.JComponent canvas, String title) {
            myCanvas = canvas ;
            myTitle = title ;
        } ;
        public void run() {
            safeFrame = new javax.swing.JFrame(myTitle) ;
            safeFrame.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
            safeFrame.getContentPane().add(myCanvas) ;
            safeFrame.pack() ;
            safeFrame.setVisible(true) ;
        }
    }
    
    
}
