// StarField panel class for StairField lab
// This file is modified by lab stucdents

// (c) J. Dean Brock, Rebecca F. Bruce, 2003, 2004, 2007
// Department of Computer Science
// University of North Carolina at Asheville

// Your name goes here ==>

package starfield ;

import java.awt.* ;

/**
 * Panel for graphics applications to draw StarField.
 * <B>Students modify this file!</B>
 */
public class StarField extends javax.swing.JComponent {

    // According to Executive Order 10798 the ratio of the hoist (width) 
    // to the fly (length) of the US flag is 1.0 to 1.9.  The ratio of
    // the hoist of the union (the blue corner with the stars)
    // to the hoist of the entire flag is 0.5385 (7/13) and
    // the ratio of the fly of the union to the hoist of the
    // flag is 0.76.
    //
    // We use "width" and "height" as being in the other directions.
    private static final int FLY      = 760 ;
    private static final int HOIST    = 538 ;
  
    private static final int NUMSTARS =  50;

    public StarField() {
        setPreferredSize(new Dimension(FLY, HOIST)) ;
        setOpaque(true) ;
    }
    
    /**
     * Overriden paint routine to draw StarField.
     * <B>Students modify this method!</B>
     * @param origG Graphics object
     */
    public void paint( Graphics g ){
        super.paint(g) ;
        Dimension panelSize = getSize() ;
        int panelWidth  = panelSize.width ;
        int panelHeight = panelSize.height ;
        Graphics newG = g.create() ;
        newG.setColor(Color.PINK) ;
        newG.fillRect(0, 0, panelWidth, panelHeight) ;
        // Note that the flag size doesn't change with the panel size
        newG.setColor(Color.BLUE) ;
        newG.fillRect(0, 0, FLY, HOIST) ;
        
        // Foor loop to determine position of the stars and paint them
        for (int i=0; i<NUMSTARS; ++i) {
            // set variables are follows:
            int row ;   // row on the flag
            int col ;   // position within the row
            int tRow = i/11 ;
            int tCol = i%11 ;
            if (tCol<6) {
                row = tRow*2 ;
                col = tCol*2 ;
            } else {
                row = tRow*2 + 1 ;
                col = (tCol-6)*2+1 ;
            }
            // These numbers are taken from executive order
            // With fly fixed as 760, they are constants
            double F = 0.054 *(FLY/0.76) ;
            double H = 0.063 *(FLY/0.76) ;
            double K = 0.0616*(FLY/0.76) ;
            int starX = (int)((col+1)*H) ;
            int starY = (int)((row+1)*F) ;
            int starR = (int)(K*0.5) ;
            // Position and size of each star
            Star5 s = new Star5(starX, starY, starR) ;
            s.draw(newG) ;
        }   // end of for loop
    }       
}
